__all__ = ['scheme_requires_path', 'scheme_uses_netloc', 'scheme_uses_query', 'scheme_uses_fragment']

scheme_requires_path = set()
scheme_uses_netloc = set()
scheme_uses_query = set()
scheme_uses_fragment = set()

_spec = '''
@/?#
++++ http
++++ https
++   ftp
++   sftp
++ + file
++   nntp
     news
+    telnet
+ +  rtsp
++   rsync
+    ssh
++   svn
++   svn+ssh
+++  imap
++   mms
  +  sip
  +  sips
++   snmp
  +  mailto
   + thismessage
 ++  xmpp
'''

#@@ netloc/authority w/o prefix: 	xmpp:<user>@<host>[:<port>]/[<resource>][?<query>]
#@@ optional authority
# dns:example?TYPE=A;CLASS=IN
# dns://192.168.1.1/ftp.example.org?type=A
#@@ parse user/password/host/port

_spec_sets = [scheme_uses_netloc, scheme_requires_path, scheme_uses_query, scheme_uses_fragment]
_spec_len = len(_spec_sets)

for line in _spec.splitlines()[2:]:
    line = line.rstrip()
    if not line:
        continue
    spec = line[:_spec_len]
    scheme = line[_spec_len+1:]
    for ch, _set in zip(spec, _spec_sets):
        if ch == '+':
            assert scheme not in _set, scheme
            _set.add(scheme)
        else:
            assert ch == ' ', ch
